

// <APPLET code="ODE1.class" width=500 height=500> </APPLET>
// lorenz

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

class GraphCanvas extends Canvas {

    static final boolean DEBUG = false; // true;
    private static final String message =
	"graph of a function with 1 variable";
    // ˼äƴŪʥѥ᡼
    // 
    private double a, b, c, d;
    // ϰ
    private double x_max =   3.0;
    private double x_min = - 3.0;
    private double x_margin = (x_max - x_min) / 10;
    private double y_max =   3.0;
    private double y_min = - 3.0;
    private double y_margin = (y_max - y_min) / 10;
    private double z_max =   3.0;
    private double z_min = - 3.0;
    private double z_margin = (z_max - z_min) / 10;

    // ɸϤѴΤΥѥ᡼
    private int CanvasX = 400, CanvasY = 400, CanvasZ = 400 ;
    private double ratiox, ratioy, ratioz, X0, Y0, Z0;

    // 󥹥ȥ饯
    public GraphCanvas() {
	super();
    }
    public GraphCanvas(int cx, int cy, int cz) {
	super();
	CanvasX = cx; CanvasY = cy; CanvasZ = cz;
    }
    
    public void compute(double A, double B, double C, double D) {
	a = A; b = B; c = C; d = D;
	repaint();
    }

    private boolean IsIn(double x, double y, double z) {
	return (x_min <= x && x <= x_max && y_min <= y
		&& y <= y_max && z_min <= z && z <= z_max);
    }
    // ɸѴν
    private void space(double x0, double y0, double z0, double x1, double y1, double z1) {
	X0 = x0; Y0 = y0; Z0 = z0;
	ratiox = CanvasX / (x1 - x0);
	ratioy = CanvasY / (y1 - y0);
	ratioz = CanvasZ / (z1 - z0);
    }
    // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
    private int wx(double x) {
	return (int)(ratiox * (x - X0));
    }
    // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
    private int wy(double y) {
	return CanvasY - (int)(ratioy * (y - Y0));
    }
    // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
    private int wz(double z) {
	return CanvasZ - (int)(ratioz * (z - Z0));
    }
    // ϳطϤα f=(fx, fy, fz)
    private double fx(double x, double y, double z) {
	return -a*x + a*y;
    }
    private double fy(double x, double y, double z) {
	return b*x - y -x*z;
    }
    private double fz(double x, double y, double z) {
	return c*z + x*y;
    }
    // x[], y[], z[] Ƥ򥰥դˤ
    private void drawGraph(Graphics g, double x0, double y0, double z0, double T) {
	double h = 0.01 / Math.sqrt(a * a + b * b + c * c + d * d);
	if (T < 0.0)
	    h = - h;
	int iter = (int)Math.rint(Math.abs(T / h));
	double x = x0;
	double y = y0;
	double z = z0;
	double new_x, new_y, new_z;
	for (int i = 0; i <= iter; i++) {
	    double k1x = h * fx(x, y, z);
	    double k1y = h * fy(x, y, z);
	    double k1z = h * fz(x, y, z);
	    double k2x = h * fx(x + k1x / 2, y + k1y / 2, z + k1z / 2);
	    double k2y = h * fy(x + k1x / 2, y + k1y / 2, z + k1z / 2);
	    double k2z = h * fz(x + k1x / 2, y + k1y / 2, z + k1z / 2);
	    double k3x = h * fx(x + k2x / 2, y + k2y / 2, z + k2z / 2);
	    double k3y = h * fy(x + k2x / 2, y + k2y / 2, z + k2z / 2);
	    double k3z = h * fz(x + k2x / 2, y + k2y / 2, z + k2z / 2);
	    double k4x = h * fx(x + k3x, y + k3y, z + k3z);
	    double k4y = h * fy(x + k3x, y + k3y, z + k3z);
	    double k4z = h * fz(x + k3x, y + k3y, z + k3z);
	    new_x = x + (k1x + 2 * k2x + 2 * k3x + k4x) / 6;
	    new_y = y + (k1y + 2 * k2y + 2 * k3y + k4y) / 6;
	    new_z = z + (k1z + 2 * k2z + 2 * k3z + k4z) / 6;
	    if (IsIn(x, y,z) && IsIn(new_x, new_y, new_z))
		g.drawLine(wx(x), wy(y), wz(z),
			   wx(new_x), wy(new_y), wz(new_z));
	    x = new_x; y = new_y; z = new_z; 
	}
    }
    public void paint(Graphics g) {
	//
	space(x_min - x_margin, y_min - y_margin,z_min - z_margin,
	      x_max + x_margin, y_max + y_margin, z_max + z_margin);
	//
	setBackground(Color.blue);
	//
	g.setColor(Color.black);
	g.drawLine(wx(x_min), wy(0.0), wz(0.0), wx(x_max), wy(0.0), wz(0.0));
	g.drawLine(wx(0.0), wy(y_min), wz(0.0), wx(0.0), wy(y_max), wz(0.0));
	g.drawLine(wx(0.0), wy(0.0), wz(z_min), wx(0.0), wy(0.0), wz(z_max));
	//
	g.setColor(Color.yellow);
	int n = 18;
	double dt = 2 * Math.PI / n;
	double Time = 10.0;
	for (int i = 0; i < n; i++) {
	    double t = i * dt;
	    drawGraph(g, Math.cos(t), Math.sin(t),   Time);
	    drawGraph(g, Math.cos(t), Math.sin(t), - Time);
	}
	n=80; dt= 2 * Math.PI /n;
	for (int i = 0; i < n; i++) {
	    double t = i * dt, r=3;
	    drawGraph(g,r* Math.cos(t),r*Math.sin(t),   Time);
	    drawGraph(g,r* Math.cos(t), r*Math.sin(t), - Time);
	}
    }
  

    public class lorenz extends Applet implements ActionListener {
	
	private int N = 20;
	private double lambda = 0.5;
	private double Tmax = 0.5;
	// 桼ȤΥ󥿡ե (ѥ᡼)
	private Label label_a, label_b, label_c, label_d;
	private TextField input_a, input_b, input_c, input_d;
	private double a, b, c, d;
	private Button startB;
	//
	private GraphCanvas gc;
	
	private void ReadFields() {
	    a = Double.valueOf(input_a.getText()).doubleValue();
	    b = Double.valueOf(input_b.getText()).doubleValue();
	    c = Double.valueOf(input_c.getText()).doubleValue();
	    d = Double.valueOf(input_d.getText()).doubleValue();
	}
    }
    //  (ѿѰդȺɸϤνʤ)
    public void init() {
	// ʥ롦쥤
	setLayout(null);
	// a, b, c, d Ϥ뤿Υƥȡե
	add(label_a = new Label("a=")); label_a.setBounds(100, 30, 40, 30);
	add(label_b = new Label("b=")); label_b.setBounds(250, 30, 40, 30);
	add(label_c = new Label("c=")); label_c.setBounds(100, 70, 40, 30);
	add(label_d = new Label("d=")); label_d.setBounds(250, 70, 40, 30);
	add(input_a = new TextField("" + 1)); input_a.setBounds(150, 30, 100, 30);
	add(input_b = new TextField("" + 0)); input_b.setBounds(300, 30, 100, 30);
	add(input_c = new TextField("" + 0)); input_c.setBounds(150, 70, 100, 30);
	add(input_d = new TextField("" + 1)); input_d.setBounds(300, 70, 100, 30);
	// Ʒ׻ܥ
	startB = new Button("Restart");
	add(startB);
	startB.setBounds(420, 45, 50, 30);
	startB.addActionListener(this);

	// Х
	gc = new GraphCanvas();
	add(gc);
	gc.setBounds(50, 100, 400, 400);
	ReadFields();
	gc.compute(a, b, c, d);
    }

    // ܥ򲡤줿顢ƥȡեɤƤɤ߼äơ
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == startB) {
	    ReadFields();
	    gc.compute(a, b, c, d);
	}
    }
}
