// <APPLET code="lorenz1.class" width=500 height=500> </APPLET>
// lorenz

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

class GraphCanvas extends Canvas {

    static final boolean DEBUG = false; // true;
    private static final String message =
        "graph of a function with 1 variable";
    // ˼äƴŪʥѥ᡼
    // Lorenz η
    private double sigma, r, b;
    // 
    private double iv_x, iv_y, iv_z;
    // ϰ
    private double x_max =   30.0;
    private double x_min = - 30.0;
    private double x_margin = (x_max - x_min) / 10;
    private double z_max =   50.0;
    private double z_min = - 5.0;
    private double z_margin = (z_max - z_min) / 10;

    // ɸϤѴΤΥѥ᡼
    private int CanvasX = 400, CanvasY = 400, CanvasZ = 400 ;
    private double ratiox, ratioy, ratioz, X0, Y0, Z0;

    // 󥹥ȥ饯
    public GraphCanvas() {
        super();
    }
    public GraphCanvas(int cx, int cy, int cz) {
        super();
        CanvasX = cx; CanvasY = cy; CanvasZ = cz;
    }

    public void compute(double Sigma, double R, double B,
                        double X0, double Y0, double Z0)
    {
        sigma = Sigma; r = R; b = B;
        iv_x = X0; iv_y = Y0; iv_z = Z0;
        repaint();
    }

    private boolean IsIn(double x, double z) {
        return (x_min <= x && x <= x_max && z_min <= z && z <= z_max);
    }
    // ɸѴν
    private void space(double x0, double z0, double x1, double z1) {
        X0 = x0; Z0 = z0;
        ratiox = CanvasX / (x1 - x0);
        ratioz = CanvasZ / (z1 - z0);
    }
    // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
    private int wx(double x) {
        return (int)(ratiox * (x - X0));
    }
    // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
    private int wz(double z) {
        return CanvasZ - (int)(ratioz * (z - Z0));
    }
    // ϳطϤα f=(fx, fy, fz)
    private double fx(double x, double y, double z) {
        return - sigma * x + sigma * y;
    }
    private double fy(double x, double y, double z) {
        return r*x - y - x * z;
    }
    private double fz(double x, double y, double z) {
        return -b * z + x * y;
    }
    // x[], y[], z[] Ƥ򥰥դˤ
    private void drawGraph(Graphics g,
                           double x0, double y0, double z0, double T)
    {
        double h = 0.01;
        if (T < 0.0)
            h = - h;
        int iter = (int)Math.rint(Math.abs(T / h));
        double x = x0;
        double y = y0;
        double z = z0;
        double new_x, new_y, new_z;
        for (int i = 0; i <= iter; i++) {
            double k1x = h * fx(x, y, z);
            double k1y = h * fy(x, y, z);
            double k1z = h * fz(x, y, z);
            double k2x = h * fx(x + k1x / 2, y + k1y / 2, z + k1z / 2);
            double k2y = h * fy(x + k1x / 2, y + k1y / 2, z + k1z / 2);
            double k2z = h * fz(x + k1x / 2, y + k1y / 2, z + k1z / 2);
            double k3x = h * fx(x + k2x / 2, y + k2y / 2, z + k2z / 2);
            double k3y = h * fy(x + k2x / 2, y + k2y / 2, z + k2z / 2);
            double k3z = h * fz(x + k2x / 2, y + k2y / 2, z + k2z / 2);
            double k4x = h * fx(x + k3x, y + k3y, z + k3z);
            double k4y = h * fy(x + k3x, y + k3y, z + k3z);
            double k4z = h * fz(x + k3x, y + k3y, z + k3z);
            new_x = x + (k1x + 2 * k2x + 2 * k3x + k4x) / 6;
            new_y = y + (k1y + 2 * k2y + 2 * k3y + k4y) / 6;
            new_z = z + (k1z + 2 * k2z + 2 * k3z + k4z) / 6;
            if (IsIn(x, z) && IsIn(new_x, new_z))
                g.drawLine(wx(x), wz(z), wx(new_x), wz(new_z));
            x = new_x; y = new_y; z = new_z; 
        }
    }
    public void paint(Graphics g) {
        //
        space(x_min - x_margin, z_min - z_margin,
              x_max + x_margin, z_max + z_margin);
        //
        setBackground(Color.blue);
        //
        g.setColor(Color.black);
        g.drawLine(wx(x_min), wz(0.0), wx(x_max), wz(0.0));
        g.drawLine(wx(0.0), wz(0.0), wx(0.0), wz(0.0));
        g.drawLine(wx(0.0), wz(z_min), wx(0.0), wz(z_max));
        //
        g.setColor(Color.yellow);
        //
        double Time = 100.0;
        drawGraph(g, iv_x, iv_y, iv_z, Time);
    }
}

public class lorenz1 extends Applet implements ActionListener {
    private int N = 20;
    private double lambda = 0.5;
    private double Tmax = 0.5;
    // 桼ȤΥ󥿡ե (ѥ᡼)
    private Label label_sigma, label_r, label_b;
    private Label label_x0, label_y0, label_z0;
    private TextField input_sigma, input_r, input_b;
    private TextField input_x0, input_y0, input_z0;
    private double sigma, r, b;
    // 
    private double x0, y0, z0;
    private Button startB;
    //
    private GraphCanvas gc;

    private void ReadFields() {
        sigma = Double.valueOf(input_sigma.getText()).doubleValue();
        r = Double.valueOf(input_r.getText()).doubleValue();
        b = Double.valueOf(input_b.getText()).doubleValue();
        x0 = Double.valueOf(input_x0.getText()).doubleValue();
        y0 = Double.valueOf(input_y0.getText()).doubleValue();
        z0 = Double.valueOf(input_z0.getText()).doubleValue();
    }
    //  (ѿѰդȺɸϤνʤ)
    public void init() {
        // ʥ롦쥤
        setLayout(null);
        // sigma, r, b Ϥ뤿Υƥȡե
        add(label_sigma = new Label("sigma="));
        label_sigma.setBounds(40, 10, 40, 20);
        add(input_sigma = new TextField("" + 10.0));
        input_sigma.setBounds(90, 10, 80, 20);

        add(label_r = new Label("r="));
        label_r.setBounds(190, 10, 40, 20);
        add(input_r = new TextField("" + 28.0));
        input_r.setBounds(240, 10, 80, 20);

        add(label_b = new Label("b="));
        label_b.setBounds(340, 10, 40, 20);
        add(input_b = new TextField("" + 8.0/3.0));
        input_b.setBounds(390, 10, 80, 20);

        //  x0, y0, z0 Ϥ뤿Υƥȡե
        add(label_x0 = new Label("x0="));
        label_x0.setBounds(40, 40, 40, 20);
        add(input_x0 = new TextField("" + 0.5));
        input_x0.setBounds(90, 40, 80, 20);

        add(label_y0 = new Label("y0="));
        label_y0.setBounds(190, 40, 40, 20);
        add(input_y0 = new TextField("" + 0.5));
        input_y0.setBounds(240, 40, 80, 20);

        add(label_z0 = new Label("z0="));
        label_z0.setBounds(340, 40, 40, 20);
        add(input_z0 = new TextField("" + 0.5));
        input_z0.setBounds(390, 40, 80, 20);

        // Ʒ׻ܥ
        startB = new Button("Restart");
        add(startB);
        startB.setBounds(230, 70, 50, 20);
        startB.addActionListener(this);

        // Х
        gc = new GraphCanvas();
        add(gc);
        gc.setBounds(50, 100, 400, 400);
        ReadFields();
        gc.compute(sigma, r, b, x0, y0, z0);
    }

    // ܥ򲡤줿顢ƥȡեɤƤɤ߼äơ
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == startB) {
            ReadFields();
            gc.compute(sigma, r, b, x0, y0, z0);
        }
    }
}
