

// <APPLET code="van_der_pol1.class" width=500 height=500> </APPLET>
// van Der Pol

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

class GraphCanvas extends Canvas {

  static final boolean DEBUG = false; // true;
  private static final String message = "graph of a function with 1 variable";
  // ˼äƴŪʥѥ᡼
  // 
  private double a;
  // ϰ
  private double x_max =   3.0;
  private double x_min = - 3.0;
  private double x_margin = (x_max - x_min) / 10;
  private double y_max =   3.0;
  private double y_min = - 3.0;
  private double y_margin = (y_max - y_min) / 10;

  // ɸϤѴΤΥѥ᡼
  private int CanvasX = 400, CanvasY = 400;
  private double ratiox, ratioy, X0, Y0;

  // 󥹥ȥ饯
  public GraphCanvas() {
    super();
  }
  public GraphCanvas(int cx, int cy) {
    super();
    CanvasX = cx; CanvasY = cy;
  }

  public void compute(double A) {
    a = A;
    repaint();
  }

  private boolean IsIn(double x, double y) {
    return (x_min <= x && x <= x_max && y_min <= y && y <= y_max);
  }
  // ɸѴν
  private void space(double x0, double y0, double x1, double y1) {
    X0 = x0; Y0 = y0;
    ratiox = CanvasX / (x1 - x0);
    ratioy = CanvasY / (y1 - y0);
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wx(double x) {
    return (int)(ratiox * (x - X0));
  }
  // 桼ɸ (ɺɸ) 򥦥ɥɸ (ǥХɸ)
  private int wy(double y) {
    return CanvasY - (int)(ratioy * (y - Y0));
  }
  // ϳطϤα f=(fx, fy)
  private double fx(double x, double y) {
    return y;
  }
  private double fy(double x, double y) {
    return -x +a*((1 - x*x)*y);
  }
  // x[], y[] Ƥ򥰥դˤ
  private void drawGraph(Graphics g, double x0, double y0, double T) {
    double h = 0.01 / Math.sqrt(a * a);
    if (T < 0.0)
      h = - h;
    int iter = (int)Math.rint(Math.abs(T / h));
    double x = x0;
    double y = y0;
    double new_x, new_y;
    for (int i = 0; i <= iter; i++) {
      double k1x = h * fx(x, y);
      double k1y = h * fy(x, y);
      double k2x = h * fx(x + k1x / 2, y + k1y / 2);
      double k2y = h * fy(x + k1x / 2, y + k1y / 2);
      double k3x = h * fx(x + k2x / 2, y + k2y / 2);
      double k3y = h * fy(x + k2x / 2, y + k2y / 2);
      double k4x = h * fx(x + k3x, y + k3y);
      double k4y = h * fy(x + k3x, y + k3y);
      new_x = x + (k1x + 2 * k2x + 2 * k3x + k4x) / 6;
      new_y = y + (k1y + 2 * k2y + 2 * k3y + k4y) / 6;
      if (IsIn(x, y) && IsIn(new_x, new_y))
	  g.drawLine(wx(x), wy(y), wx(new_x), wy(new_y));
      x = new_x; y = new_y;
    }
  }

  public void paint(Graphics g) {
    //
    space(x_min - x_margin, y_min - y_margin,
	  x_max + x_margin, y_max + y_margin);
    //
    setBackground(Color.blue);
    //
    g.setColor(Color.black);
    g.drawLine(wx(x_min), wy(0.0), wx(x_max), wy(0.0));
    g.drawLine(wx(0.0), wy(y_min), wx(0.0), wy(y_max));
    //
    g.setColor(Color.yellow);
    int n = 18;
    double dt = 2 * Math.PI / n;
    double Time = 10.0;
    for (int i = 0; i < n; i++) {
      double t = i * dt;
      drawGraph(g, Math.cos(t), Math.sin(t),   Time);
      drawGraph(g, Math.cos(t), Math.sin(t), - Time);
    }
    n=80; dt= 2 * Math.PI /n;
    for (int i = 0; i < n; i++) {
     double t = i * dt, r=3;
      drawGraph(g,r* Math.cos(t),r*Math.sin(t),   Time);
      drawGraph(g,r* Math.cos(t), r*Math.sin(t), - Time);
    }
  }
}

public class van_der_pol1 extends Applet implements ActionListener {

  private int N = 20;
  private double lambda = 0.5;
  private double Tmax = 0.5;
  // 桼ȤΥ󥿡ե (ѥ᡼)
  private Label label_a;
  private TextField input_a;
  private double a;
  private Button startB;
  //
  private GraphCanvas gc;

  private void ReadFields() {
    a = Double.valueOf(input_a.getText()).doubleValue();
  
  }
  //  (ѿѰդȺɸϤνʤ)
  public void init() {
    // ʥ롦쥤
    setLayout(null);
    // a Ϥ뤿Υƥȡե
    add(label_a = new Label("a=")); label_a.setBounds(70, 50, 40, 30);
   
    add(input_a = new TextField("" + 1)); input_a.setBounds(120, 50, 100, 30);
   
    // Ʒ׻ܥ
    startB = new Button("Restart");
    add(startB);
    startB.setBounds(300, 50, 50, 30);
    startB.addActionListener(this);

    // Х
    gc = new GraphCanvas();
    add(gc);
    gc.setBounds(50, 100, 400, 400);
    ReadFields();
    gc.compute(a);
  }

  // ܥ򲡤줿顢ƥȡեɤƤɤ߼äơ
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == startB) {
      ReadFields();
      gc.compute(a);
    }
  }
}

